-- keycardOS "bootloader", has no access to basalt
-- intended for checking for updates, and automatically updating basalt if it is missing

LAST_USED = os.time()

local function checkForUpdate()
    current_time = os.time()
    difference = math.abs(current_time - LAST_USED)
    print("Checking for update... difference: " .. tostring(difference))
    --its been considerable time since the keypad was interacted with, therefore it's time to force an update down the users throat (microsoft moment)
    if difference > .5 then

        --logic for updating

    end

end

function updateChecker()

    while true do
        checkForUpdate()
        sleep(1)
    end

end

local function boot()
    KEYPADOS_VERSION = "3.0"

    monitor = peripheral.find("monitor")
    monitor.clear()
    monitor.setTextScale(0.5)
    y = 1

    function mPrint(text)
        monitor.setCursorPos(1,y)
        monitor.write(text)
        y = y + 1
    end

    mPrint("keypadOS v" .. KEYPADOS_VERSION)

    if fs.exists("basalt.lua") then
        mPrint("Basalt found!")
    else
        mPrint("Download basalt...")
        basalt_code = http.get("https://raw.githubusercontent.com/Pyroxenium/Basalt/master/docs/versions/latest.lua").readAll()
        mPrint("Install basalt...")
        local file = fs.open("basalt.lua", "w")
        file.write(basalt_code)
        file.close()
        mPrint("Rebooting...")
        os.reboot()
    end

    monitor.setTextScale(1)
    monitor.clear()

end

boot()
